;**********************************************************************
; HGC - INIT
; 88-02-25  M. Benz
; Stellt die Prozeduren INITGRAF und INITTEXT zur Initialisierung der
; Hercules Grafikkarte zur Verfgung
;**********************************************************************
 
Index   equ     03B4H                       ; port address
Cntrl   equ     03B8H
Graf    equ       82H                       ; control code
Text    equ       20H                       ; control code
ScrnOn  equ        8H                       ; screen on

DATA    segment public 'data'
TTable  db  61H,50H,52H,0FH,19H,06H,19H,19H,02H,0DH,0BH,0CH
GTable  db      35H,2DH,2EH,07H,5BH,02H,57H,57H,02H,03H,00H,00H
DATA    ends
DGROUP  group   DATA
        assume  cs:CODE, ds:DGROUP, ss:DGROUP

CODE    segment 'code'
public  INITGRAF
public  INITTEXT


;**********************************************************************
; INITGRAF
; 88-02-25   M. Benz
; Setzt Hercules-Graphikkarte in Graphikmode
;**********************************************************************

INITGRAF proc  far

        push    bp

        mov     al,Graf
        lea     si,GTable

        push    ax

        mov     dx,Cntrl
        out     dx,al
        mov     ax,ds                       ; es:si auf Parameter-
        mov     es,ax                       ; Tabelle setzen

        mov     dx,Index
        mov     cx,12                       ; 12 Parameters
        xor     ah,ah

GParm:  mov     al,ah
        out     dx,al                       ; register number
        inc     dx
        lodsb
        out     dx,al                       ; output data

        inc     ah                          ; next value
        dec     dx
        loop    GParm

        mov     dx,Cntrl
        pop     ax
        add     al,ScrnOn
        out     dx,al                       ; screen on

        pop     bp
        ret
INITGRAF endp


;**********************************************************************
; INITTEXT
; 88-02-25   M. Benz
; Setzt Hercules-Graphikkarte in Textmodus
;**********************************************************************

INITTEXT proc   far

        push    bp

        mov     al,Text
        lea     si,TTable

        push    ax

        mov     dx,Cntrl
        out     dx,al
        mov     ax,ds                       ; es:si auf Parameter-
        mov     es,ax                       ; Tabelle setzen

        mov     dx,Index
        mov     cx,12                       ; 12 Parameters
        xor     ah,ah

TParm:  mov     al,ah
        out     dx,al                       ; register number
        inc     dx
        lodsb
        out     dx,al                       ; output data

        inc     ah                          ; next value
        dec     dx
        loop    TParm

        mov     dx,Cntrl
        pop     ax
        add     al,ScrnOn
        out     dx,al                       ; screen on

        pop     bp
        ret
INITTEXT endp

CODE    ends
        end
