(**************************************************************************
*                                                                         *
*  package  INPUT                              Version  1.11              *
*                                                                         *
***************************************************************************
     *                                                                    *
     *  J. Desteffani and M. Benz  IA85        09.03.1987 - 07.12.1987    *
     *                                                                    *
     *  p u r p o s e :                                                   *
     *                                                                    *
     *     >>> Dieses Package verhindert bei einem falschen Input den     *
     *         Absturz des Programmes.                                    *
     *                                                                    *
     *  e n t r i e s :                                                   *
     *                                                                    *
     *  FUNCTION Get_Boolean : BOOLEAN;                                   *
     *                                                                    *
     *  FUNCTION Get_Real   (default   : REAL) :REAL;                     *
     *                                                                    *
     *  PROCEDURE Real_Test (    x     :T_string80;                       *
     *                       VAR zahl  :REAL;                             *
     *                       VAR error :BOOLEAN);                         *
     *                                                                    *
     **********************************************************************)


   PROCEDURE Print_Error (x, y :INTEGER);
   BEGIN
      GotoXY (1,24);
      DelLine;
      WRITE ('ERROR in input');
      GotoXY (x,y);
   END;

(*------------------------------------------------------------------------*)

   PROCEDURE Boolean_Test (ch :CHAR; VAR res, error :BOOLEAN);
   BEGIN
      IF ch in ['y','j','Y','J','n','N','0','1'] THEN BEGIN
         error:= FALSE;
         IF ch in ['y','j','Y','J','1'] THEN BEGIN
            res:= TRUE;
         END
         ELSE BEGIN
            res:= FALSE;
         END;
      END
      ELSE BEGIN
         error:= TRUE;
      END;
   END;

(*------------------------------------------------------------------------*)

     PROCEDURE Real_Test (    x     :T_string80;
                          VAR zahl  :REAL;
                          VAR error :BOOLEAN);

      VAR
         possible, dezimalpunkt,
         durchlauf, exp_flag,
         vorzeichen, vorzeichen_exp :BOOLEAN;
         index,
         exponent, index_dez_pkt    :INTEGER;
         mantisse                   :REAL;

   BEGIN
      zahl:= 0.0;
      error:= TRUE;
      possible:= TRUE;
      dezimalpunkt:= FALSE;
      index_dez_pkt:= 0;
      exp_flag:= FALSE;
      vorzeichen:= FALSE;
      vorzeichen_exp:= FALSE;
      mantisse:= 0.0;
      exponent:= 0;
      index:= 1;

      IF length(x) > 0 THEN BEGIN
         REPEAT
            durchlauf:= FALSE;
            CASE x[index] OF
            '+', '-':
               BEGIN
                  IF index <> 1 THEN BEGIN
                     possible := FALSE;
                  END
                  ELSE BEGIN
                     IF x[index] = '-' THEN vorzeichen:= TRUE;
                  END;
                  durchlauf:= TRUE;
               END;
            'E', 'e':
               BEGIN
                  IF exp_flag THEN BEGIN
                     possible:= FALSE;
                  END
                  ELSE BEGIN
                     exp_flag:= TRUE;
                     dezimalpunkt:= TRUE;
                     IF index+1 <= length(x) THEN BEGIN
                        IF x[index+1] IN ['+','-'] THEN BEGIN
                           index:=index+1;
                           IF x[index] = '-' THEN vorzeichen_exp:= TRUE;
                           IF index+1 > length(x) THEN possible:= FALSE;
                        END;
                     END
                     ELSE BEGIN
                        possible:= FALSE;
                     END;
                  END;
                  durchlauf:= TRUE;
               END;
            '.':
               BEGIN
                  IF dezimalpunkt THEN BEGIN
                     possible:= FALSE;
                  END
                  ELSE BEGIN
                     dezimalpunkt:= TRUE;
                  END;
                  durchlauf:= TRUE;
               END;
            '0'..'9':
               BEGIN
                  IF exp_flag THEN BEGIN
                     exponent:= 10*exponent+ord(x[index])-48;
                  END
                  ELSE BEGIN
                     IF dezimalpunkt THEN BEGIN
                        index_dez_pkt:= index_dez_pkt+1;
                     END;
                     mantisse:= 10*mantisse+ord(x[index])-48;
                  END;
                  durchlauf := TRUE;
               END;
            END; (* of case *)
            index:= index+1;
            IF NOT durchlauf THEN BEGIN
               possible := FALSE;
            END;
         UNTIL (NOT possible) OR (index > length (x));

         IF possible THEN BEGIN
            IF (exponent<>0) AND (x[1] IN ['e','E'])  OR
               ((x[2] IN ['e','E']) AND (x[1] IN ['-','+']))
               THEN BEGIN
               mantisse:= 1;
            END;
            IF vorzeichen_exp THEN exponent:= -exponent;
            IF mantisse <> 0 THEN BEGIN
               IF LN(mantisse)/LN(10)-index_dez_pkt+exponent <= 38 THEN BEGIN
                  FOR index:= 1 TO index_dez_pkt DO BEGIN
                     mantisse:= mantisse/10;
                  END;
                  IF vorzeichen_exp THEN BEGIN
                     IF exponent > -200 THEN BEGIN
                        FOR index:= exponent TO -1 DO BEGIN
                           mantisse:= mantisse/10;
                        END;
                     END
                     ELSE BEGIN
                        mantisse:= 0;
                     END;
                  END
                  ELSE BEGIN
                     FOR index:= 1 TO exponent DO BEGIN
                        mantisse:= mantisse*10;
                     END;
                  END;
                  IF vorzeichen THEN mantisse:= -mantisse;
                  zahl:= mantisse;
                  error:= FALSE;
               END;
            END
            ELSE BEGIN
               (* Zahl = 0 *)
               zahl:= 0;
               error:= FALSE;
            END;
         END;
      END;
   END;

(*------------------------------------------------------------------------*)

   FUNCTION Get_Boolean: BOOLEAN;
      VAR
         error  :BOOLEAN;
         enter  :CHAR;
         moved  :BOOLEAN;
         x, y   :INTEGER;
   BEGIN
      x:=WhereX; y:=WhereY;
      REPEAT
         REPEAT UNTIL KeyPressed;
         READ (kbd, enter);
         Boolean_Test (enter, moved, error);
         IF error THEN Print_Error (x,y);
      UNTIL NOT error;
      Get_Boolean:= moved;
   END;

(*------------------------------------------------------------------------*)

   FUNCTION Get_Real (default :REAL) : REAL;
      VAR
         error  :BOOLEAN;
         enter  :T_string80;
         moved  :REAL;
         x, y   :INTEGER;
   BEGIN
      x:=WhereX; y:=WhereY;
      REPEAT
         enter:='';
         READ (enter);
         IF enter='' then moved:=default
         ELSE BEGIN
             Real_Test (enter, moved, error);
             IF error THEN Print_Error (x,y);
         END;
      UNTIL NOT error;
      Get_Real:= moved;
   END;
