(**********************************************************************
*                                                                     *
*   package   P C - P L O T T Y - G R A P H I C                       *
*                                                                     *
***********************************************************************
    *                                                                 *
    *   Version:    1.10                                              *
    *                                                                 *
    *   Date:       88-04-07                                          *
    *                                                                 *
    *   Programmer: M. Benz                                           *
    *                                                                 *
    *   Purpose:                                                      *
    *       Dieses Package stellt alle notwendigen Grafikprozeduren   *
    *       fr das PC-Plotty zur Verfgung.                          *
    *                                                                 *
    *   Inout:                                                        *
    *       procedure Plot_Screen (Ws_type              : integer;    *
    *                            Scale                  : boolean;    *
    *                            Anz_Pkt                : integer;    *
    *                            Xvon, Xbis, Yvon, Ybis : real;       *
    *                            var Tabelle            : T_Tabelle;  *
    *                            var Error_code         : integer)    *
    *       procedure Inq_AnzPkt (Ws_type               : integer;    *
    *                            var Anz_Pkt, Error_code: integer)    *
    *                                                                 *
    ******************************************************************)

{$I Skala}

    (******************************************************************
    *                                                                 *
    *   procedure Plot_Screen                                         *
    *                                                                 *
    *******************************************************************
        *                                                             *
        *   Version:    1.10                                          *
        *                                                             *
        *   Date:       88-04-07                                      *
        *                                                             *
        *   Programmer: M. Benz                                       *
        *                                                             *
        *   Purpose:                                                  *
        *       Diese Prozedur plottet die Tabelle, wahlweise mit     *
        *       oder ohne Skala auf den Bildschirm.                   *
        *                                                             *
        **************************************************************)

    procedure Plot_Screen (Scale                : boolean;
                         Anz_Pkt                : integer;
                         Xvon, Xbis, Yvon, Ybis : real;
                         var Tab_X, Tab_Y       : T_Tab_Unit;
                         var Error_code         : integer);
        type
            T_Plot_Tab   = array [1..Max_Pkt] of integer;
        var
            I, X_ScaleAdd, Y_ScaleAdd   : integer;
            X_ScaleFac, Y_ScaleFac      : real;
            XTab, YTab                  : T_Plot_Tab;
            Ch                          : char;
    begin
        if Scale then begin
            Skala (Xvon, Xbis, Yvon, Ybis);
            X_ScaleFac:=(Xmax-Xmin)/(Xbis-Xvon);
            Y_ScaleFac:=(Ymax-Ymin)/(Ybis-Yvon);
            X_ScaleAdd:=Xmin-round(Xvon*X_ScaleFac);
            Y_ScaleAdd:=Ymin-round(Yvon*Y_ScaleFac);
        end {if}
        else begin
            X_ScaleFac:=Xmax/(Xbis-Xvon);
            Y_ScaleFac:=Ymax/(Ybis-Yvon);
            X_ScaleAdd:=-round(Xvon*X_ScaleFac);
            Y_ScaleAdd:=-round(Yvon*Y_ScaleFac);
        end {else};
        for I:=1 to Anz_Pkt do begin
            XTab[I]:=round(Tab_X[I]*X_ScaleFac)+X_ScaleAdd;
            YTab[I]:=Ymax-round(Tab_Y[I]*Y_ScaleFac)-Y_ScaleAdd;
        end {for};
        for I:=1 to Anz_Pkt-1 do begin
            Line (XTab[I], YTab[I], XTab[I+1], YTab[I+1]);
        end {for};
        read (Ch);
    end {Plot_Screen};



    (******************************************************************
    *                                                                 *
    *   procedure Inq_AnzPkt                                          *
    *                                                                 *
    *******************************************************************
        *                                                             *
        *   Version:    1.00                                          *
        *                                                             *
        *   Date:       88-04-07                                      *
        *                                                             *
        *   Programmer: M. Benz                                       *
        *                                                             *
        *   Purpose:                                                  *
        *       Diese Prozedur gibt die Anzahl Pixels in X-Richtung   *
        *       fr die angegebene Graphikkarte zurck.               *
        *                                                             *
        **************************************************************)

    procedure Inq_AnzPkt (var Anz_Pkt, Error_code   : integer);
    begin
        Error_code:=0;
            Anz_Pkt:=720;
            Anz_Pkt:=640;
            Error_code:=2801;
    end {Inq_AnzPkt};

